#include "TM1618.h"
#include "io430.h"
 
     //0-9ʾ
/**********
TM1618 оƬSEG1    SEG2    SEG3    SEG4    SEG5    SEG12   SEG13   SEG14
LEDλ   5       4       8       1       2       6       7       3
             SEG4      SEG5    SEG14   SEG2     SEG1    SEG12   SEG13  SEG3
              S1       S2       S3      S4      S5      S6      S7     S8         H------>L
              1         1       1       1       1       1       0       0 ------> 1101 1101----<0XBB    0
              0         1       1       0       0       0       0       0 ------> 1001 0000----<0X90    1
              1         1       0       1       1       0       1       0 ------> 0101 1011----<0X5B    2
              1         1       1       1       0       0       1       0 ------> 1101 1010----<0XDA    3
              0         1       1       0       0       1       1       0 ------> 1111 0000----<0XF0    4
              1         0       1       1       0       1       1       0 ------> 1110 1010----<0XEA    5
              1         0       1       1       1       1       1       0 ------> 1110 1011----<0XEB    6
              1         1       1       0       0       0       0       0 ------> 1001 1000----<0X98    7
              1         1       1       1       1       1       1       0 ------> 1111 1011----<0XFB    8
              1         1       1       1       0       1       1       0 ------> 1111 1010----<0XFA    9
              1         0       0       1       1       1       1       0 ------> 0110 1011----<0x6B    E
              0         0       0       0       1       0       1       0 ------> 0100 0001----<0X41    r
              0         0       1       1       1       0       1       0 ------> 1100 0011----<0xc3    o
              1         0       0       1       1       1       0       0 ------> 0010 1011----<0x2B
              
***********/
const unsigned char DispDate[10]={0xbb, 0X90,0X5B,0XDA,0XF0,0XEA,0XEB,0X98,0XFB,0XFA}; 

void Send8bit(unsigned char sbit)
{
    unsigned char i=0;
    for(i=0;i<8;i++)
    {
        CLK_0;
        if(sbit&0x01){ DIO_1;}
        else{DIO_0;}
        delay_us(5);
       
        CLK_1;
        sbit>>=1;
    }
    CLK_0;
    DIO_0;
}


void SendCmd(unsigned char scmd)
{
    STB_1;
    delay_us(2);
    STB_0;
    Send8bit(scmd);
}

void TM1618FixDisp(unsigned char faddr, unsigned char sdate)
{
    SendCmd(0x00);
    SendCmd(0x44);
    SendCmd(faddr);
    Send8bit(sdate&0x1f);
    SendCmd(faddr+1);
    Send8bit((sdate&0xe0)>>2);
    SendCmd(0x8b);
}

void TM1618AutoDisp(unsigned char faddr, unsigned char sdate)
{
   unsigned char i=0;
   
    SendCmd(0x00);
    SendCmd(0x40);
    SendCmd(faddr);
    for(i=0; i<4; i++)
    {  
      Send8bit(sdate&0x1f);
      Send8bit((sdate&0xe0)>>2);
    }
    SendCmd(0x8b);
}






void TM1618Init(void)
{
    P2DIR = BIT0 + BIT1 +BIT2;  //Set OUTPUT
    TM1618AutoDisp(0xc0,0x00); 
}


void  TM1618DispInt(int sdate) //ʾ-9999999
{
     if(sdate<0)    //ʾΪ
     {
          if(sdate>-10)
          {
              TM1618FixDisp(0xc2, 0x00);  //һλ,СλSEG3
              TM1618FixDisp(0xc4, 0x00);   //ڶλ,м
              TM1618FixDisp(0xc6, Neg);  //λ
              TM1618FixDisp(0xc0, DispDate[sdate*(-1)]);  //λ
          }else if( sdate>-100)
          {
              TM1618FixDisp(0xc2, 0x00);  //һλ,СλSEG3
              TM1618FixDisp(0xc4, Neg);    //ڶλ,м
              TM1618FixDisp(0xc6, DispDate[sdate*(-1)/10]);  //λ
              TM1618FixDisp(0xc0, DispDate[sdate*(-1)%10]);  //λ
          }else if( sdate>-1000)
          {
              TM1618FixDisp(0xc2, Neg);  //һλ,СλSEG3
              TM1618FixDisp(0xc4, DispDate[sdate*(-1)/100]);    //ڶλ,м
              TM1618FixDisp(0xc6, DispDate[sdate*(-1)/10%10]);  //λ
              TM1618FixDisp(0xc0, DispDate[sdate*(-1)%10]);  //λ
          }else{
                TM1618FixDisp(0xc2, 0x6B);  //һλ,СλSEG3
                TM1618FixDisp(0xc4, 0X41);   //ڶλ,м
                TM1618FixDisp(0xc6, 0X41);  //λ
                TM1618FixDisp(0xc0, 0xc3);  //λ
          }
     }else    //ʾ
     {
          if(sdate<10)
          {
              TM1618FixDisp(0xc2, 0x00);  //һλ,СλSEG3
              TM1618FixDisp(0xc4, 0x00);   //ڶλ,м
              TM1618FixDisp(0xc6, 0x00);  //λ
              TM1618FixDisp(0xc0, DispDate[sdate]);  //λ
          }else if( sdate<100)
          {
              TM1618FixDisp(0xc2, 0x00);  //һλ,СλSEG3
              TM1618FixDisp(0xc4, 0x00);    //ڶλ,м
              TM1618FixDisp(0xc6, DispDate[sdate/10]);  //λ
              TM1618FixDisp(0xc0, DispDate[sdate%10]);  //λ
          }else if( sdate<1000)
          {
              TM1618FixDisp(0xc2, 0x00);  //һλ,СλSEG3
              TM1618FixDisp(0xc4, DispDate[sdate/100]);    //ڶλ,м
              TM1618FixDisp(0xc6, DispDate[sdate/10%10]);  //λ
              TM1618FixDisp(0xc0, DispDate[sdate%10]);  //λ
          }else if(sdate <10000){
                TM1618FixDisp(0xc2, DispDate[sdate/1000]);  //һλ,СλSEG3
                TM1618FixDisp(0xc4, DispDate[sdate/100%10]);    //ڶλ,м
                TM1618FixDisp(0xc6, DispDate[sdate/10%10]);  //λ
                TM1618FixDisp(0xc0, DispDate[sdate%10]);  //λ
          }else
          {
                TM1618FixDisp(0xc2, 0x6B);  //һλ,СλSEG3
                TM1618FixDisp(0xc4, 0X41);   //ڶλ,м
                TM1618FixDisp(0xc6, 0X41);  //λ
                TM1618FixDisp(0xc0, 0xc3);  //λ
          }
     }
     
}


void TM1618DispFloat(float sdate)  //-9.999.9
{
     if(sdate<0)
     {
         if(sdate>-9.99)
         {
              TM1618FixDisp(0xc2, NegP);  //һλ,СλSEG3
              TM1618FixDisp(0xc4, DispDate[((int)(sdate*(-10))/10)]);   //ڶλ,м
              TM1618FixDisp(0xc6, DispDate[((int)(sdate*(-10))%10)]);  //λ
              TM1618FixDisp(0xc0, 0X2B);  //λ  
         }else
         {
            TM1618FixDisp(0xc2, 0x6B);  //      E
            TM1618FixDisp(0xc4, 0X41);  //      r
            TM1618FixDisp(0xc6, 0X41);  //      r
            TM1618FixDisp(0xc0, 0xc3);  //      o
         }
     }else
     {
         if(sdate<9.99)
         {
              TM1618FixDisp(0xc2, 0x00);  //һλ,СλSEG3
              TM1618FixDisp(0xc4, DispDate[((int)(sdate*(10))/10)]);   //ڶλ,м
              TM1618FixDisp(0xc6, DispDate[((int)(sdate*(10))%10)]);  //λ
              TM1618FixDisp(0xc0, 0X2B);  //λ  
         }else if(sdate<99.99)
         {
              TM1618FixDisp(0xc2, DispDate[((int)(sdate*(10))/100)] | 0x04);  //һλ,СλSEG3
              TM1618FixDisp(0xc4, DispDate[((int)(sdate*(10))/10%10)]);   //ڶλ,м
              TM1618FixDisp(0xc6, DispDate[((int)(sdate*(10))%10)]);  //λ
              TM1618FixDisp(0xc0, 0X2B);    //C
         }else
         {
            TM1618FixDisp(0xc2, 0x6B);  //      E
            TM1618FixDisp(0xc4, 0X41);  //      r
            TM1618FixDisp(0xc6, 0X41);  //      r
            TM1618FixDisp(0xc0, 0xc3);  //      o
         }
     }
}

void TM1618DispTime(unsigned char tH, unsigned char tM, unsigned char sP)
{
     if(sP==0x04 || sP==0x00)
     {
       if(tH<10)  //ʾСʱ
       {
            TM1618FixDisp(0xc2, 0x00);  //һλ,СλSEG3
            TM1618FixDisp(0xc4, DispDate[tH] | sP);   //ڶλ,м
       }else if(tH<13)
       {
            TM1618FixDisp(0xc2,  DispDate[tH/10]);  //һλ,СλSEG3
            TM1618FixDisp(0xc4,  DispDate[tH%10] | sP);   //ڶλ,м
       }else
       {
            TM1618FixDisp(0xc2, 0x6B);  //      E
            TM1618FixDisp(0xc4, 0X41);  //      r
            TM1618FixDisp(0xc6, 0X41);  //      r
            TM1618FixDisp(0xc0, 0xc3);  //      o
       }
    
        if(tM<10)  //ʾ
       {
            TM1618FixDisp(0xc6, DispDate[0]);  //һλ,СλSEG3
            TM1618FixDisp(0xc0, DispDate[tM]);   //ڶλ,м
       }else if(tH<60)
       {
            TM1618FixDisp(0xc6,  DispDate[tM/10]);  //һλ,СλSEG3
            TM1618FixDisp(0xc0,  DispDate[tM%10]);   //ڶλ,м
       }else
       {
            TM1618FixDisp(0xc2, 0x6B);  //      E
            TM1618FixDisp(0xc4, 0X41);  //      r
            TM1618FixDisp(0xc6, 0X41);  //      r
            TM1618FixDisp(0xc0, 0xc3);  //      o
       }
     }else
     {
            TM1618FixDisp(0xc2, 0x6B);  //      E
            TM1618FixDisp(0xc4, 0X41);  //      r
            TM1618FixDisp(0xc6, 0X41);  //      r
            TM1618FixDisp(0xc0, 0xc3);  //      o
     }
}



