#ifndef  _TM1618_H_
#define _TM1618_H_


#define CPU_F ((double)8000000)
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0))
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0))



/****IO  Set***/
#define STB_1  P2OUT=BIT0
#define STB_0  P2OUT&=~BIT0

#define CLK_1  P2OUT=BIT1
#define CLK_0  P2OUT&=~BIT1

#define DIO_1  P2OUT=BIT2
#define DIO_0  P2OUT&=~BIT2

#define Neg   0x40
#define NegP  0x44
#define WIP   0x04
#define WOP   0x00

void TM1618Init(void);
void TM1618AutoDisp(unsigned char faddr, unsigned char sdate);
void TM1618FixDisp(unsigned char faddr, unsigned char sdate);

void  TM1618DispInt(int sdate);
void TM1618DispFloat(float sdate);
void TM1618DispTime(unsigned char tH, unsigned char tM, unsigned char sP);

#endif


